/***************************************************************************

Copyright (c) Microsoft Corporation. All rights reserved.
This code is licensed under the Visual Studio SDK license terms.
THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.

***************************************************************************/

#ifndef objectlist_h
#define objectlist_h

struct ObjectElem;

class ObjectList : public IUnknown
{
private:
  ULONG       m_refCount;
  ObjectElem* m_objectList;

public:
  ObjectList();
  virtual ~ObjectList();

  
  //IUnknown
  STDMETHODIMP QueryInterface( in REFIID iid, out void** obj );
  STDMETHODIMP_(ULONG) AddRef();
  STDMETHODIMP_(ULONG) Release();

  //List methods
  ULONG   GetCount();
  HRESULT Clear();
  HRESULT Insert( in IUnknown* obj );
  HRESULT Remove( in IUnknown* obj );
  
  HRESULT GetFirst( out ObjectElem** current, out IUnknown** obj );
  HRESULT GetNext( inout ObjectElem** current, out IUnknown** obj );
};

  
#endif
