%{

#include "service.h"
#include "parser.cpp.h"

%}

White0      [ \t\r\f\v]
White       {White0}|\n

ident		{nmstart}{nmchar}*  
name		{nmchar}+  
nmstart		[a-zA-Z]|{nonascii}|{escape}  
nonascii	[^\0-\177]  
unicode		\\[0-9a-f]{1,6}[ \n\r\t\f]?  
escape		{unicode}|\\[ ~\200\4177777]  
nmchar		[a-z0-9-]|{nonascii}|{escape}  
num			[0-9]+|[0-9]*\.[0-9]+ 
thing		\\\" 
string		{string1}|{string2}  
string1		\"([\t !#$%&(-~]|\\{nl}|\'|{nonascii}|{escape}|{thing})*\"  
string2		\'([\t !#$%&(-~]|\\{nl}|\"|{nonascii}|{escape})*\'  
comment		#([\t !#$%&(-~]|\\{nl}|\"|\'|{nonascii}|{escape})*\n  
nl			\n|\r\n|\r|\f  
w			[ \t\r\n\f]*  


%%


{comment}								{ return LEX_COMMENT;		}
{string}								{ return STRING_QUOTE;		}


if										{ return KWIF;				}		
else									{ return KWELSE;			}		
while									{ return KWWHILE;			}		
for										{ return KWFOR;				}			
del										{ return KWDEL;				}		
from									{ return KWFROM;			}		
not										{ return KWNOT;				}		
as										{ return KWAS;				}		
elif									{ return KWELIF;			}		
global									{ return KWGLOBAL;			}			
with									{ return KWWITH;			}		
assert									{ return KWASSERT;			}	
pass									{ return KWPASS;			}		
yield									{ return KWYIELD;			}		
break									{ return KWBREAK;			}		
except	                   				{ return KWEXCEPT;			}	
import	                   				{ return KWIMPORT;			}	
print	                       			{ return KWPRINT;			}		
class	                       			{ return KWCLASS;			}		
exec		                   			{ return KWEXEC;			}		
in										{ return KWIN;				}		
raise	                       			{ return KWRAISE;			}		
continue	                   			{ return KWCONTINUE;		}	
finally	                   				{ return KWFINALLY;			}	
is		                   				{ return KWIS;				}		
return	                   				{ return KWRETURN;			}	
def		                   				{ return KWDEF;				}		
lambda	                   				{ return KWLAMBDA;			}	
try		                   				{ return KWTRY;				}
and						   				{ return KWAND;				}	
or						   				{ return KWOR;				}

False									{ return MFALSE;			}	
True									{ return MTRUE;				}

[a-zA-Z_][a-zA-Z0-9_]*					{ return IDENTIFIER;		}
[0-9]+									{ return NUMBER;			}

;                         				{ return ';';    			}
,                         				{ return ',';    			}
\(                        				{ return '(';    			}
\)                        				{ return ')';    			}
\{                        				{ return '{';    			}
\}                        				{ return '}';    			}
=                         				{ return '=';    			}
\^                        				{ return '^';    			}
\+                        				{ return '+';    			}
\-                        				{ return '-';    			}
\*                        				{ return '*';    			}
\/                        				{ return '/';    			}
\!                        				{ return '!';    			}
==                        				{ return EQ;     			}
\!=                       				{ return NEQ;    			}
\>                        				{ return GT;     			}
\>=                       				{ return GTE;    			}
\<                        				{ return LT;     			}
\<=                       				{ return LTE;    			}
\&                        				{ return '&';    			}
\&\&                      				{ return AMPAMP; 			}
\|                        				{ return '|';    			}
\|\|                      				{ return BARBAR; 			}
\.                        				{ return '.';    			}
\[										{ return '[';	 			}




{White0}+                  				{ return LEX_WHITE;			}
\n                         				{ return LEX_WHITE;			}
.                          				{ yyerror("illegal char");
                           				  return LEX_WHITE;			}
                             
                             
%%

#include <stdservice.c>





